﻿using SoftwareInstallationContracts.BindingModels;
using SoftwareInstallationContracts.ViewModels;
using SoftwareInstallationDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SoftwareInstallationListImplement.Models
{
    public class Shop : IShopModel
    {
        public string ShopName { get; private set; } = string.Empty;
        public string ShopAddress { get; private set; } = string.Empty;

        public DateTime OpeningDate { get; private set; }

        public Dictionary<int, (IPackageModel, int)> ShopPackages { get; private set; } = new();

        public int Id { get; private set; }

        public static Shop? Create(ShopBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Shop()
            {
                Id = model.Id,
                ShopName = model.ShopName,
                ShopAddress = model.ShopAddress,
                OpeningDate = model.OpeningDate,
                ShopPackages = new()
            };
        }

        public void Update(ShopBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            ShopName = model.ShopName;
            ShopAddress = model.ShopAddress;
            OpeningDate = model.OpeningDate;
            ShopPackages = model.ShopPackages;
        }

        public ShopViewModel GetViewModel => new()
        {
            Id = Id,
            ShopName = ShopName,
            ShopAddress = ShopAddress,
            OpeningDate = OpeningDate,
            ShopPackages = ShopPackages
        };

        public int PackageMaxCount => throw new NotImplementedException();
    }
}
